package com.sun.java.swing.plaf.windows;

import javax.swing.plaf.UIResource;
import javax.swing.UIManager;
import java.awt.Component;
import java.awt.Graphics;
import javax.swing.plaf.ComponentUI;
import javax.swing.JComponent;
import javax.swing.plaf.basic.BasicSpinnerUI;

public class WindowsSpinnerUI extends BasicSpinnerUI
{
    public WindowsSpinnerUI() {
    }
    
    public static ComponentUI createUI(JComponent component) {
        return new WindowsSpinnerUI();
    }
    
    @Override
    public void paint(Graphics g, JComponent c) {
        if (XPStyle.getXP() != null) {
            this.paintXPBackground(g, c);
        }
        super.paint(g, c);
    }
    
    private TMSchema.State getXPState(JComponent component) {
        TMSchema.State state = TMSchema.State.NORMAL;
        if (!component.isEnabled()) {
            state = TMSchema.State.DISABLED;
            return state;
        }
        return state;
    }
    
    private void paintXPBackground(Graphics graphics, JComponent component) {
        XPStyle xp = XPStyle.getXP();
        if (xp == null) {
            return;
        }
        xp.getSkin(component, TMSchema.Part.EP_EDIT).paintSkin(graphics, 0, 0, component.getWidth(), component.getHeight(), this.getXPState(component));
        return;
    }
    
    @Override
    protected Component createPreviousButton() {
        if (XPStyle.getXP() != null) {
            XPStyle.GlyphButton c = new XPStyle.GlyphButton(this.spinner, TMSchema.Part.SPNP_DOWN);
            c.setPreferredSize(UIManager.getDimension("Spinner.arrowButtonSize"));
            c.setRequestFocusEnabled(false);
            this.installPreviousButtonListeners(c);
            return c;
        }
        return super.createPreviousButton();
    }
    
    @Override
    protected Component createNextButton() {
        if (XPStyle.getXP() != null) {
            XPStyle.GlyphButton c = new XPStyle.GlyphButton(this.spinner, TMSchema.Part.SPNP_UP);
            c.setPreferredSize(UIManager.getDimension("Spinner.arrowButtonSize"));
            c.setRequestFocusEnabled(false);
            this.installNextButtonListeners(c);
            return c;
        }
        return super.createNextButton();
    }
    
    private UIResource getUIResource(Object[] array) {
        int i = 0;
        while (i < array.length) {
            if ((array[i] instanceof UIResource)) {
                return (UIResource)array[i];
            }
            ++i;
        }
        return null;
    }
}
